> ## Documentation Index
> Fetch the complete documentation index at: https://docs.topsort.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Get upload users signed url for a segment.

> Retrieve a signed URL for uploading a segment user file.

This endpoint returns a pre-signed URL that allows you to securely upload a segment user file.

File requirements:
- The file must be in plain text format (".txt").
- It should not contain headers.
- Each line must represent a single opaque user ID.

The signed URL can be used to upload the file directly via an HTTP PUT request.
For more information, see the [AWS documentation on uploading objects using presigned URLs](https://docs.aws.amazon.com/AmazonS3/latest/userguide/PresignedUrlUploadObject.html).

Returns
-------
    dict: A dictionary containing the signed URL and any additional metadata required for upload.



## OpenAPI

````yaml /openapi.json get /public/v1/segment-service/segments/{segment-id}/signed-url
openapi: 3.1.0
info:
  title: Topsort Endpoints v2 API Reference
  description: >
    In order for a storefront to be able to run auctions in Topsort and report
    auction-related events back to Topsort,

    both the `/v2/auctions` and `/v2/events` endpoints must be integrated.

    Below are the endpoint and model definitions for each.
  contact:
    email: wicha@topsort.com
  license:
    name: Apache 2.0
    url: http://www.apache.org/licenses/LICENSE-2.0.html
  x-logo:
    url: https://assets.topsort.com/Topsort_logo_icon_dark.svg
    backgroundColor: '#fff'
    altText: Topsort
  version: 2.0.0
servers:
  - url: https://api.topsort.com
    description: Base API URL
security: []
tags:
  - name: Auctions
    description: >-
      An auction determines which products should be promoted based on the
      vendors' bids.
  - name: Events
    description: >-
      Events are sent to Topsort as part of the attribution and reporting
      journey.
  - name: Toptimize
    description: >
      An out-of-the-box solution for prediction, ranking, retrieval, and other
      elements of ad selection.
  - name: Toppie API
    description: Toppie management API.
  - name: Campaign API
    description: Full-featured campaign management API for banners and sponsored listings.
  - name: Catalog API
    description: Products catalog management API.
  - name: Billing API
    description: Marketplace and Vendor Billing management API.
  - name: Reporting API
    description: Marketplace, Vendor, Campaign, and product reporting API.
  - name: Invitation API
    description: Vendor invitations management API.
  - name: User API
    description: User management API.
  - name: Webhooks API
    description: Webhooks API that allows event-driven automation.
  - name: Assets API
    description: Assets management API.
  - name: Segments Service
    description: Segments Service.
  - name: Forecasting Service
    description: Toptimize Forecasting Service.
  - name: Offsite Ads API
    description: Offsite Ads API that allows to manage offsite ads campaigns.
  - name: Media API
    description: Ad configuration API.
paths:
  /public/v1/segment-service/segments/{segment-id}/signed-url:
    get:
      tags:
        - Segments Service
      summary: Get upload users signed url for a segment.
      description: >-
        Retrieve a signed URL for uploading a segment user file.


        This endpoint returns a pre-signed URL that allows you to securely
        upload a segment user file.


        File requirements:

        - The file must be in plain text format (".txt").

        - It should not contain headers.

        - Each line must represent a single opaque user ID.


        The signed URL can be used to upload the file directly via an HTTP PUT
        request.

        For more information, see the [AWS documentation on uploading objects
        using presigned
        URLs](https://docs.aws.amazon.com/AmazonS3/latest/userguide/PresignedUrlUploadObject.html).


        Returns

        -------
            dict: A dictionary containing the signed URL and any additional metadata required for upload.
      operationId: get_signed_url
      parameters:
        - name: segment-id
          in: path
          required: true
          schema:
            type: string
            description: The ID of the segment.
          description: The ID of the segment.
        - name: action
          in: query
          required: false
          schema:
            $ref: '#/components/schemas/Advanced_APIs_SegmentSyncAction'
            description: >-
              The action to perform on the segment. Possible values are 'add',
              'remove', or 'replace'. The 'replace' action will first remove all
              existing users from the segment before adding the new ones.
            default: add
          description: >-
            The action to perform on the segment. Possible values are 'add',
            'remove', or 'replace'. The 'replace' action will first remove all
            existing users from the segment before adding the new ones.
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Advanced_APIs_CreatePresignedUrlResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Advanced_APIs_HTTPValidationError'
      security:
        - Advanced_APIs_HTTPBearer: []
components:
  schemas:
    Advanced_APIs_SegmentSyncAction:
      type: string
      enum:
        - add
        - remove
        - replace
      title: SegmentSyncAction
    Advanced_APIs_CreatePresignedUrlResponse:
      properties:
        url:
          type: string
          maxLength: 2083
          minLength: 1
          format: uri
          title: Url
          description: The presigned URL.
      type: object
      required:
        - url
      title: CreatePresignedUrlResponse
    Advanced_APIs_HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/Advanced_APIs_ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    Advanced_APIs_ValidationError:
      properties:
        loc:
          items:
            oneOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    Advanced_APIs_HTTPBearer:
      type: http
      description: >-
        A valid API key generated in Topsort's UI. Use the TSE API key if
        calling auctions or events API, otherwise use the TSC API key.
      scheme: bearer

````